clear all;
close all;
clc;

%===============================================
%Example 13.1.  Investment equation
%===============================================

%Initial Data Setup.  Used for all examples

Data = ...
   [1963   596.7      90.9    0.7167    3.23
    1964   637.7      97.4    0.7277    3.55
	1965   691.1     113.5    0.7436    4.04
	1966   756.0     125.7    0.7676    4.50
	1967   799.6     122.8    0.7906    4.19
	1968   873.4     133.3    0.8254    5.16
	1969   944.0     149.3    0.8679    5.87
	1970   992.7     144.2    0.9145    5.95
	1971  1077.6     166.4    0.9601    4.88
	1972  1185.9     195.0    1.0000    4.50
	1973  1326.4     229.8    1.0575    6.44
	1974  1434.2     228.7    1.1508    7.83
	1975  1549.2     206.1    1.2579    6.25
	1976  1718.0     257.9    1.3234    5.50
	1977  1918.3     324.1    1.4005    5.46
	1978  2163.9     386.6    1.5042    7.46
	1979  2417.8     423.0    1.6342   10.28
	1980  2631.7     401.9    1.7842   11.77
	1981  2954.1     474.9    1.9514   13.42
	1982  3073.0     414.5    2.0688   11.02];

Names = strvcat('GNP','Invest','Price','Interest');

%vypusteni pozorovani s nulovymi vydaji

[Nobs,Nvar]=size(Data);

Year = Data(2:end,1);
GNP = Data(2:end,2);    %nominal mld.
Invest = Data(2:end,3); %hrube domaci investice mld.
Price = Data(:,4);  %implicitni cenovy deflator pro GNP
Interest = Data(:,5); %prumerna diskontni sayba NY FED

realGNP = GNP./Price(2:end);
realInvest = Invest./Price(2:end);
realInterest = Interest(2:end)-(Price(2:end)-Price(1:end-1))./Price(1:end-1)*100;


yy = realInvest;
XX = [ones(size(yy)) realInterest realGNP];
result = ols(yy,XX);
vnames = strvcat('realInvest','konstanta','realInterest','realGNP');
prt_reg(result,vnames);

figure
plot(Year,result.resid)

resultco = olsc(yy,XX);
vnames = strvcat('realInvest','konstanta','realInterest','realGNP');
prt_reg(resultco,vnames);

