close all;
clear all;
clc;

% USAauto.dat dokumentace

% 23 dat ke spotrebe benzinu v USA
% Maddala (1988)

load USAauto.dat;

[n nvar] = size(USAauto);

Rok = USAauto(2:n,1);  % Rok
K   = USAauto(2:n,2);  % Vzdalenost ujeta osobnim autem za rok      [mile]
C   = USAauto(2:n,3);  % Pocet automobilu v USA                     [mil. kusu]
M   = USAauto(2:n,4);  % Vzdalenost ujeta autem na galon benznu    [mile]
Pg  = USAauto(2:n,5);  % Cena benzinu                               [index 1953 = 100]
Pt  = USAauto(2:n,6);  % Cena verejn dopravy                       [index 1967 = 1]
Pop = USAauto(2:n,7);  % Obyvatelstvo USA                           [mil.osob]
L   = USAauto(2:n,8);  % pracovni sila v USA                        [mil.osob]
Y   = USAauto(2:n,9);  % Disponibilni prijem na obyvatele USA       [v cenach roku 1958]


C_1 = USAauto(1:n-1,3);
const = ones(n-1,1);

LL = L./Pop; %zamestnanost

%pocet automobilu - metoda OLS
fprintf('\n \n');
fprintf('********Pocet automobilu v USA*******************');
res_C = ols(C,[const,C_1,Pg,Pt,Pop,LL,Y]);
vnames_C = strvcat('C','Konstanta','C_1','Pg','Pt','Pop','LL','Y');
prt_reg(res_C,vnames_C);
fprintf('\b***************************************************************\n');

%stanoveni reciporocnich vah jako podilu vyrovnane zavisle promenne a abs.
%rezidua
w = abs(res_C.yhat)./abs(res_C.resid);
wnorm = w./sum(w);
Wnorm = diag(wnorm).^2;
res_C_wls = wls(C,[const,C_1,Pg,Pt,Pop,LL,Y],Wnorm);
my_prt(res_C_wls,vnames_C);

%GLS
res_C_gls = gls(C,[const,C_1,Pg,Pt,Pop,LL,Y]);
my_prt(res_C_gls,vnames_C);

%pocet automobilu - metoda OLS - Cochran-Orcutt
fprintf('\n \n');
fprintf('********Pocet automobilu v USA*******************');
resc_C = olsc(C,[const,C_1,Pg,Pt,Pop,LL,Y]);
vnamesc_C = strvcat('C','Konstanta','C_1','Pg','Pt','Pop','LL','Y');
prt_reg(resc_C,vnamesc_C);
fprintf('\b***************************************************************\n');
